'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _UseCase2 = require('./UseCase');

var _UseCase3 = _interopRequireDefault(_UseCase2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This is the default use case returned
 * by the domain when asking for a not implemented
 * use case. It allows to work on the client with
 * a work in progress feature. The execute() method
 * returns a promise which warns in console that
 * the requested method is not implemented yet.
 *
 * */
var NotImplementedUseCase = function (_UseCase) {
  (0, _inherits3.default)(NotImplementedUseCase, _UseCase);

  /**
   * @param {string} key The requested use case not being implemented
   */
  function NotImplementedUseCase(key) {
    (0, _classCallCheck3.default)(this, NotImplementedUseCase);

    var _this = (0, _possibleConstructorReturn3.default)(this, (NotImplementedUseCase.__proto__ || (0, _getPrototypeOf2.default)(NotImplementedUseCase)).call(this));

    _this._key = key;
    return _this;
  }

  /**
   * @override
   */


  (0, _createClass3.default)(NotImplementedUseCase, [{
    key: 'execute',
    value: function execute() {
      return _promise2.default.resolve(console.warn('Service ' + this._key + ' is not implemented in the current version of the domain'));
    }
  }]);
  return NotImplementedUseCase;
}(_UseCase3.default); /* eslint no-console:0 */


exports.default = NotImplementedUseCase;