'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Fetcher2 = require('./Fetcher');

var _Fetcher3 = _interopRequireDefault(_Fetcher2);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import getPerf from '@schibstedspain/sui-perf'
// import measureAxios from '@schibstedspain/sui-perf/src/measure-axios'

/**
 * @implements Fetcher
 */
var AxiosFetcher = function (_Fetcher) {
  (0, _inherits3.default)(AxiosFetcher, _Fetcher);

  /**
   * @param {Object} deps
   * @param {Config} deps.config
   */
  function AxiosFetcher(_ref) {
    var config = _ref.config;
    (0, _classCallCheck3.default)(this, AxiosFetcher);

    var _this = (0, _possibleConstructorReturn3.default)(this, (AxiosFetcher.__proto__ || (0, _getPrototypeOf2.default)(AxiosFetcher)).call(this, { config: config }));

    _this._axios = _axios2.default.create(config);
    // const perf = getPerf(config.get('serverRequestId') || 'default')
    // measureAxios(perf)(this._axios)
    return _this;
  }

  /**
   * Get method
   * @param {String} url
   * @param {Object} options
   * @return {Object}
   */


  (0, _createClass3.default)(AxiosFetcher, [{
    key: 'get',
    value: function get(url, options) {
      return this._axios.get(url, options);
    }

    /**
     * Post method
     * @method post
     * @param {String} url
     * @param {String} body
     * @param {Object} options
     * @return {Object}
     */

  }, {
    key: 'post',
    value: function post(url, body, options) {
      return this._axios.post(url, body, options);
    }

    /**
     * Put method
     * @method put
     * @param {String} url
     * @param {String} body
     * @param {Object} options
     * @return {Object}
     */

  }, {
    key: 'put',
    value: function put(url, body, options) {
      return this._axios.put(url, body, options);
    }

    /**
     * Delete method
     * @method delete
     * @param {String} url
     * @param {Object} options
     * @return {Object}
     */

  }, {
    key: 'delete',
    value: function _delete(url, options) {
      return this._axios.delete(url, options);
    }
  }]);
  return AxiosFetcher;
}(_Fetcher3.default);

exports.default = AxiosFetcher;